import { Form } from "antd";
import ProInputCard from "components/ProInputCard/ProInputCard.tsx";
import ProRatioGroups from "components/ProRatioGroups/ProRatioGroups.tsx";
import { selectCart, updateEstimateTime } from "features/order/orderSlice.ts";
import useBreakPoint from "hooks/useBreakPoint.ts";
import { BottomSheet } from "pages/cart/components/timeEstimate/BottomSheet.tsx";
import { Dialog } from "pages/cart/components/timeEstimate/Dialog.tsx";
import { useState } from "react";
import { useTranslation } from "react-i18next";
import { useAppDispatch, useAppSelector } from "redux/hooks.ts";

export default function TimeEstimateCard() {
  const { t } = useTranslation();
  const dispatch = useAppDispatch();
  const { estimateTimeDate } = useAppSelector(selectCart);
  const { isDesktop } = useBreakPoint();
  const [estimateWay, setEstimateWay] = useState("now");
  const [isEstimateTimeOpen, setIsEstimateTimeOpen] = useState(false);

  const handleEstimateTimeSave = (date: Date, time: string) => {
    dispatch(updateEstimateTime({ date, time }));
  };

  const handleEstimateTimeClose = () => {
    setIsEstimateTimeOpen(false);
  };

  return (
    <>
      <ProInputCard title={t("cart.estimateTime")}>
        <Form.Item
          name="estimateWay"
          required
          rules={[
            { required: true, message: t("cart.pleaseSelectEstimateTime") },
          ]}
        >
          <ProRatioGroups
            options={[
              { label: t("cart.now"), value: "now", price: "" },
              { label: t("cart.later"), value: "later", price: "" },
            ]}
            value={estimateWay}
            onRatioClick={(value) => {
              if (value === "now") {
                setEstimateWay(value);
                handleEstimateTimeSave(new Date(), "now");
              } else {
                setEstimateWay(value);
                setIsEstimateTimeOpen(true);
              }
            }}
          />
        </Form.Item>
      </ProInputCard>
      {isDesktop ? (
        <Dialog
          isOpen={isEstimateTimeOpen}
          onClose={handleEstimateTimeClose}
          initialDate={estimateTimeDate}
          onSave={handleEstimateTimeSave}
        />
      ) : (
        <BottomSheet
          isOpen={isEstimateTimeOpen}
          onClose={handleEstimateTimeClose}
          initialDate={estimateTimeDate}
          onSave={handleEstimateTimeSave}
        />
      )}
    </>
  );
}
